<?php

/**
 * co_contrato_consulta actions.
 *
 * @package    contratacion
 * @subpackage co_contrato
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
require_once 'HTMLPurifier.auto.php';
require 'HTMLPurifier.autoload.php';

class co_contrato_consultaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CO_CONTRATO_V',
        'CO_CONTRATISTA',
        'CO_SELECCION_EP',
        'CO_INICIO_CONTRATO',
        'CO_CATEGORIA',
        'CO_ESTUDIOS_PREVIOS',
        'CO_MODALIDAD_SEL',
        'CO_LEGALIZA_CONTRATO',
        'CO_CONTRATO_ARL',
        'RPS_CONTRATO_V'
        //'RPS_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_CONTRATISTA' =>
        array(
            'id_contratista' => 'CO_CONTRATO_V'
        ),
        'CO_SELECCION_EP' =>
        array(
            'id_seleccion_ep' => 'CO_CONTRATO_V'
        ),
        'CO_INICIO_CONTRATO,LEFT' =>
        array(
            'id_inicio_contrato' => 'CO_CONTRATO_V'
        ),
        'CO_CATEGORIA,LEFT' =>
        array(
            'id_categoria' => 'CO_CONTRATO_V'
        ),
        'CO_ESTUDIOS_PREVIOS,LEFT' =>
        array(
            'id_estudios_previos' => 'CO_SELECCION_EP'
        ),
        'CO_MODALIDAD_SEL,LEFT' =>
        array(
            'id_modalidad_sel' => 'CO_ESTUDIOS_PREVIOS'
        ),
        'CO_LEGALIZA_CONTRATO,LEFT' =>
        array(
            'id_contrato' => 'CO_CONTRATO_V'
        ),
        'RPS_CONTRATO_V,LEFT' =>
        array(
            'id_rp-rp' => 'CO_LEGALIZA_CONTRATO',
            'rp_sgr-sgr' => 'CO_LEGALIZA_CONTRATO',
            'vigencia_rp-vigencia' => 'CO_LEGALIZA_CONTRATO'
        ),
        /*'RPS_V,LEFT' =>
        array(
            'id_rp-rp' => 'CO_LEGALIZA_CONTRATO'
        ),*/
        'CO_CONTRATO_ARL,LEFT' =>
        array(
            'id_contrato' => 'CO_CONTRATO_V'
        ),
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CO_CONTRATO_V' =>
        array(
            'id_contrato' => 'id_contrato',
            'no_contrato' => 'no_contrato',
            'fecha_contrato' => 'fecha_contrato',
            'id_anhos' => 'id_anhos',
            'id_seleccion_ep' => 'id_seleccion_ep',
            'id_tipo_contrato' => 'id_tipo_contrato',
            'id_contratista' => 'id_contratista',
            'id_categoria' => 'id_categoria',
//            'plazo' => 'plazo',
//            'objeto' => 'objeto',
            'valor' => 'valor',
            'estado' => 'estado',
            'activo' => 'activo',
            'liquidado' => 'liquidado',
            'adjunto_contrato' => 'adjunto_contrato',
            'adjunto_resolucion' => 'adjunto_resolucion',
            'fecha_anu' => 'fecha_anu',
            'motivo_anu' => 'motivo_anu',
            'id_tipo_convenio' => 'id_tipo_convenio',
            'valor_anticipo' => 'valor_anticipo',
            'porcentaje_anticipo' => 'porcentaje_anticipo',
            'id_inicio_contrato' => 'id_inicio_contrato',
            'terminacion' => 'terminacion',
            'dias_plazo' => 'dias_plazo',
            'meses_plazo' => 'meses_plazo',
            'anhos_plazo' => 'anhos_plazo',
            'liquidacion' => 'liquidacion',
            'meses_liquida' => 'meses_liquida',
            'carta_aceptacion' => 'carta_aceptacion',
            'tipo' => 'tipo',
            'id_ordenador_gasto' => 'ordenador_gasto',
            'modalidad' => 'modalidad',
            'proceso' => 'proceso',
            'completo_contra' => 'completo_contra',
            'tipo_contrato' => 'tipo_contrato',
            'completo_supervisor' => 'completo_supervisor',
            'completo_ordenador' => 'completo_ordenador',
            'tipo_convenio' => 'tipo_convenio',
            'id_supervisor' => 'id_supervisor',
            'valor_cdp' => 'valor_cdp',
            'valor_cdp,-,valor' => 'valor_ahorro',
//            'consideraciones' => 'consideraciones',
//            'perfeccionamiento_ejec' => 'perfeccionamiento_ejec',
//            'obliga_gen_contratista' => 'obliga_gen_contratista',
//            'valor_texto' => 'valor_texto',
//            'supervisor' => 'supervisor',
            'fuente_financiamiento' => 'fuente_financiamiento',
            'fecha_secop' => 'fecha_secop',
            'fecha_liquidacion_cont' => 'fecha_liquidacion_cont'
        ),
        'CO_CONTRATISTA' =>
        array(
            'id_tipo_iden' => 'id_tipo_iden',
            'num_doc' => 'num_doc',
            'dv' => 'dv',
            'telefono' => 'telefono',
            'celular' => 'celular',
            'direccion' => 'direccion',
            'email' => 'email',
            'representante_legal' => 'representante_legal',
            'ciudad' => 'ciudad',
            'factor_rh' => 'factor_rh',
            'fecha_nacimiento' => 'fecha_nacimiento',
            'ciudad_nacimiento' => 'ciudad_nacimiento'
        ),
        'CO_SELECCION_EP' =>
        array(
            'id_estudios_previos' => 'id_estudios_previos'
        ),
        'CO_INICIO_CONTRATO' =>
        array(
            'descripcion' => 'ini_contra'
        ),
        'CO_CATEGORIA' =>
        array(
            'descripcion' => 'descripcion',
            'sueldo' => 'sueldo'
        ),
        'CO_MODALIDAD_SEL' =>
        array(
            'id_tipo_proceso' => 'id_tipo_proceso'
        ),
        'CO_LEGALIZA_CONTRATO' =>
        array(
            'id_legaliza_contrato' => 'id_legaliza_contrato',
            'id_rp' => 'id_rp',
            'fecha_aprueba_poliza' => 'fecha_aprueba_poliza',
            'fecha_inicio' => 'fecha_inicio',
            'fecha_terminacion' => 'fecha_terminacion',
            'fecha_liquidacion' => 'fecha_liquidacion',
            'adjunto_poliza' => 'adjunto_poliza',
            'adjunto_rp' => 'adjunto_rp'
        ),
        //'RPS_V' =>
        'RPS_CONTRATO_V' =>
        array(
            'rp' => 'rp',
            'vigencia' => 'vigencia_rp',
            'fecha' => 'fecha_rp',
            'valor' => 'valor_rp',
            'rp,||, - ,||,vigencia' => 'completo_rp'
        ),
        // Añadido FECHA ARL //
        'CO_CONTRATO_ARL' =>
        array(
            'fecha_cobertura_arl' => 'fecha_cobertura_arl',
        ),
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id_anhos', 'no_contrato', 'proceso', 'tipo'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CO_CONTRATO_V' =>
        array(
            'id_contrato,a' => array('!=' => array(-1)),
            'id_contrato,b' => array('=' => array('id_contrato')),
            'id_anhos' => array('=' => array('id_anhos')),
            'id_seleccion_ep' => array('=' => array('id_seleccion_ep')),
            'id_tipo_contrato' => array('=' => array('id_tipo_contrato')),
            'id_tipo_convenio' => array('=' => array('id_tipo_convenio')),
            'id_supervisor' => array('=' => array('id_supervisor')),
            'fecha_contrato' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'no_contrato' => array('=' => array('no_contrato_null')),
            'no_contrato' => array('=' => array('no_contrato')),
            'id_contratista' => array('=' => array('id_contratista')),
            'estado' => array('=' => array('estado')),
            'activo' => array('=' => array('activo')),
            'liquidado' => array('=' => array('liquidado')),
            'id_categoria' => array('=' => array('id_categoria')),
            //'id_supervisor' => array('=' => array('id_username')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_contrato'; //identificador de la tabla
    protected $id_names = array('id_contrato'); //llave primaria
    protected $field_names = array('no_contrato', 'id_anhos', 'fecha_contrato', 'id_seleccion_ep', 'id_tipo_contrato', 'id_contratista', 'plazo', 'valor',
        'estado', 'activo', 'liquidado', 'adjunto_contrato', 'objeto', 'fecha_anu', 'id_ordenador_gasto', 'id_tipo_convenio', 'valor_anticipo',
        'motivo_anu', 'porcentaje_anticipo', 'id_inicio_contrato', 'terminacion', 'dias_plazo', 'meses_plazo', 'anhos_plazo', 'liquidacion', 'meses_liquida', 'carta_aceptacion',
        'adjunto_resolucion', 'id_categoria', 'consideraciones', 'perfeccionamiento_ejec', 'obliga_gen_contratista', 'valor_texto', 'supervisor','fecha_secop','fecha_liquidacion_cont',
        'valor_mensual'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_CONTRATO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_contrato'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {

                //Actualizacion 03 de Noviembre
                //Si la categoria del contratista es diferente de null 
                //actualizo el sueldo del contrastista en la tabla TERCEROS de comisiones 
                $id_categoria = $list_data_post[0]['id_categoria'];
                $id_contratista = $list_data_post[0]['id_contratista'];

                if ($id_categoria != null || $id_categoria != "null" || $id_categoria != '') {

                    $sql = <<<EOD
select tab0.sueldo

from co_categoria tab0
where tab0.id_categoria = $id_categoria
EOD;

                    $records = CN_TABLE::executeSQL($sql);

                    $sueldo = $records[0]['sueldo'];

                    //Valida valor 0 - 20170505
                    if ($sueldo > 0) {
                        $sql = <<<EOD
select tab0.num_doc

from co_contratista tab0
where tab0.id_contratista = $id_contratista
EOD;

                        $records = CN_TABLE::executeSQL($sql);

                        $num_doc = $records[0]['num_doc'];

                        $sql = <<<EOD
update terceros set sueldo = $sueldo where nitocc = $num_doc
EOD;
                        CN_TABLE::executeSQL($sql);
                    }
                }

                $this->conn->commit();

                //ENVIO CORREO 6 - Notificacion de Registro de Contrato
//PARAMETROS GENERALES

                $subject = "Notificacion de Registro de Contrato";
                //Email Envio
                if (!isset($request["email_envio"])) {


                    //Obtenemos la entidad
                    $array = sfYaml::load(dirname(__FILE__) . '/../../../../api/config/app-gwt.yml');
                    $int = 0;
                    foreach ($array as $routeName => $routeData) {
                        //echo $routeName . "\n";
                        if ('correoEnvio' == $routeName) {
                            foreach ($routeData as $key => $value) {
                                //echo $value . "\n";
                                if ($key == 'value') {
                                    $email_envio = $value;
                                }
                            }
                        }
                        $int++;
                    }

                    $request["email_envio"] = $email_envio;
                }
                $adjunto = false;
                $ruta = "";

                /*
                 * Variable Memcache
                 */
                $progress_key = $request['progress_key'] . $request['username'];
                $this->logMessage("Valor de progress_key: " . $progress_key);

                $array_adjuntos = array();


                $sql = "
        SELECT tab0.dia_sistema||' de '||tab0.mes_sistema||' del '||anho_sistema AS FECHA_SISTEMA
           from(
            select LPAD(to_char(sysdate,'dd'),2,'0') as dia_sistema,
            trim(initcap(to_char(sysdate,'MONTH','nls_date_language=spanish'))) as mes_sistema,
            TO_CHAR(sysdate,'yyyy') as anho_sistema
            from dual
        )tab0
        ";

                $records = CN_TABLE::executeSQL($sql);
                $fecha_creacion = $records[0]['fecha_sistema'];



                $id_contrato = $list_data_post[0]['id_contrato'];

                $sql = <<<EOD
select tab0.no_contrato,tab0.id_anhos as vigencia, tab0.valor, tab0.objeto, tab0.tipo, tab0.completo_contra, tab0.completo_supervisor, tab1.id_estudios_previos

from co_contrato_v tab0
join co_seleccion_ep tab1 ON tab1.id_seleccion_ep = tab0.id_seleccion_ep
where tab0.id_contrato = $id_contrato
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $no_contrato = $records[0]['no_contrato'];
                $vigencia = $records[0]['vigencia'];
                $tipo = $records[0]['tipo'];
                $contratista = $records[0]['completo_contra'];
                $supervisor = $records[0]['completo_supervisor'];
                $objeto = $this->htmlClear($records[0]['objeto']);
                $id_estudios_previos = $records[0]['id_estudios_previos'];

                $sql = <<<EOD
select tab0.*,tab1.aplica_proceso AS APLICA_PROCESO
    from co_estudios_previos_v tab0 
    LEFT JOIN co_modalidad_sel tab1 ON tab1.id_modalidad_sel = tab0.id_modalidad_sel 
        where tab0.id_estudios_previos = $id_estudios_previos
EOD;

                $records = CN_TABLE::executeSQL($sql);

                $responsable = $records[0]['nombre_responsable'];
                $area = $records[0]['area'];
                $valor = $records[0]['valor'];
                $valor = number_format($valor);
                $modalidad = $records[0]['modalidad'];
                $abogado = $records[0]['abogado'];
                $proceso = $records[0]['proceso'];
                $aplica_proceso = $records[0]['aplica_proceso'];

                if ($aplica_proceso == 0) {
                    $titulo = "DATOS DEL ESTUDIO PREVIO";
                    $titulo2 = "Estudio Previo No.";
                } else {
                    $titulo = "DATOS DEL PROCESO";
                    $titulo2 = "Proceso No.";
                }



//1. Se realiza Consulta a la tabla de administracion alarmas para saber a quien van dirigidos los correos

                $sql = <<<EOD
select tab2.num_doc, tab2.id_tipo_doc, tab2.razon_soc, nvl(tab3.mail,'mesadeayuda@sgc.gov.co') email, tab4.descripcion as rol
from co_administra_alarma tab0
join co_rol_proceso_v tab1 ON tab1.id_rol = tab0.id_rol and tab1.id_estudios_previos = $id_estudios_previos
join interceros_v tab2 ON tab2.id_mae_ter = tab1.id_mae_ter
join interceros_du_dir_v tab3 ON tab3.id_mae_ter = tab2.id_mae_ter
join co_rol tab4 ON tab4.id_rol = tab0.id_rol                        
where tab0.id_alarma = 6 and tab1.id_mae_ter is not null
EOD;

                $records = CN_TABLE::executeSQL($sql);

                foreach ($records as $correos) {

                    $documento = $correos['num_doc'];
                    $tipo_doc = $correos['id_tipo_doc'];
                    $nombre = $correos['razon_soc'];
                    $email = $correos['email'];
                    $rol = $correos['rol'];

                    $parametros = $documento . ";$tipo_doc;" . $email . ";" . $nombre . ";Envio notificacion";

                    $datos_usuario = array();

                    if ($parametros != "") {
                        $datos_usuario = explode('/', $parametros);
                    }

//CUERPO DEL MENSAJE

                    $body = "<html><body> </body></html>";
//Body
                    $body = <<<EOD
                <html><body> 
                <br/>
                Bogotá, $fecha_creacion
                <br/>
                <br/>
                Señor(a)<br/>
                $nombre<br/>
                $rol
                <br/><br/>
                Por medio de la presente se notifica el <b>Registro de contrato No. $no_contrato de $vigencia</b><br/><br/>
                <b>DATOS DEL CONTRATO:</b><br/>
                <b>Contratista.</b> $contratista<br/><br/>
                <b>Supervisor:</b> $supervisor<br/><br/>
                <b>Tipo de Contrato:</b> $tipo<br/><br/>
                <b>Valor del Contrato:</b> $valor<br/><br/>
                <b>Objeto:</b> $objeto<br/><br/>
                <br></br>
                <b>$titulo</b>
                <br></br>
                <b>$titulo2</b> $proceso<br/><br/>
                <b>Area:</b> $area<br/><br/>
                <b>Responsable:</b> $responsable<br/><br/>
                <b>Abogado:</b> $abogado<br/><br/>
                <br/><br/>
                
                </body></html>
EOD;

                    $currentUri = "";

                    CN_TABLE::envioCorreo($request, $datos_usuario, $subject, $currentUri, $ruta, $adjunto, $progress_key, $array_adjuntos, $body);
                }
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {

        $config = HTMLPurifier_Config::createDefault();
        $purifier = new HTMLPurifier($config);

        /**
         * Limpiar valores - 20200129
         */
        $valor = $request['plazo'];
        $valor_limpio = $purifier->purify($valor);
        $request['plazo'] = $valor_limpio;
        
        $valor = $request['objeto'];
        $valor_limpio = $purifier->purify($valor);
        $request['objeto'] = $valor_limpio;
        
        $valor = $request['consideraciones'];
        $valor_limpio = $purifier->purify($valor);
        $request['consideraciones'] = $valor_limpio;

        $valor = $request['perfeccionamiento_ejec'];
        $valor_limpio = $purifier->purify($valor);
        $request['perfeccionamiento_ejec'] = $valor_limpio;

        $valor = $request['obliga_gen_contratista'];
        $valor_limpio = $purifier->purify($valor);
        $request['obliga_gen_contratista'] = $valor_limpio;

        $valor = $request['valor_texto'];
        $valor_limpio = $purifier->purify($valor);
        $request['valor_texto'] = $valor_limpio;

        $valor = $request['supervisor'];
        $valor_limpio = $purifier->purify($valor);
        $request['supervisor'] = $valor_limpio;


        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");
        //$logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            //Obtenemos la entidad
            /*
             * (SGC-1, ANM-2, SGR-3, CYC-4, COL-5, INCI-6, LOCAL-7)
             */
            $array = sfYaml::load(dirname(__FILE__) . '/../../../config/app-gwt.yml');
            $int = 0;
            foreach ($array as $routeName => $routeData) {
                //echo $routeName . "\n";
                if ('entidad_cliente' == $routeName) {
                    foreach ($routeData as $key => $value) {
                        //echo $value . "\n";
                        if ($key == 'value') {
                            $entidadCliente = $value;
                        }
                    }
                }
                $int++;
            }
            //20191028 Se aplica condicion para la generacion del autonumerico ya que la CEV(comision de la verdad) 
            //asignara numeros manualmente
            //Se quema mientras se establece una parametrizacion para saber si genera o no el autonumerico
            $aplica_autonumerico = 1;
            if ($entidadCliente == "8" || $entidadCliente == "2") {
                $aplica_autonumerico = 0;
            }



            $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];

            $request['id_anhos'] = $id_anhos;

            if ($aplica_autonumerico == 1) {
                $id_tipo_convenio = $request['id_tipo_convenio'];

                $carta_aceptacion = $request['carta_aceptacion'];

                if ($carta_aceptacion == "0" || $carta_aceptacion == false || $carta_aceptacion == "false") {


                    if ($id_tipo_convenio != "") {

                        $sql = <<<EOD
select consecutivo from co_consecutivo_convenio where id_anhos = $id_anhos
EOD;
                        $records = CN_TABLE::executeSQL($sql);
                        /*
                         * Se crea validacion para nuevo año - 20170105
                         */
                        if (count($records) > 0) {

                            $consecutivo = $records[0]['consecutivo'];

                            $request['no_contrato'] = $consecutivo;

                            $sql = <<<EOD
update co_consecutivo_convenio set consecutivo =($consecutivo+1) where id_anhos = $id_anhos
EOD;

                            CN_TABLE::executeSQL($sql);
                        } else {
                            $consecutivo = 1;

                            $request['no_contrato'] = $consecutivo;

                            $sql = <<<EOD
Insert into co_consecutivo_convenio (ID_CONSECUTIVO_CONVENIO,ID_ANHOS,CONSECUTIVO) values (null,'$id_anhos',($consecutivo+1)) 
EOD;

                            CN_TABLE::executeSQL($sql);
                        }
                    } else {

                        $sql = <<<EOD
select consecutivo from co_consec_contrato where id_anhos = $id_anhos
EOD;
                        $records = CN_TABLE::executeSQL($sql);

                        /*
                         * Se crea validacion para nuevo año - 20160105
                         */
                        if (count($records) > 0) {

                            $consecutivo = $records[0]['consecutivo'];

                            $request['no_contrato'] = $consecutivo;

                            $sql = <<<EOD
update co_consec_contrato set consecutivo =($consecutivo+1) where id_anhos = $id_anhos
EOD;

                            CN_TABLE::executeSQL($sql);
                        } else {

                            $consecutivo = 1;

                            $request['no_contrato'] = $consecutivo;

                            $sql = <<<EOD
Insert into co_consec_contrato (ID_CONSEC_CONTRATO,ID_ANHOS,CONSECUTIVO) values (null,'$id_anhos',($consecutivo+1)) 
EOD;

                            CN_TABLE::executeSQL($sql);
                        }
                    }
                } else {

                    $sql = <<<EOD
select consecutivo from co_consecutivo_ca where id_anhos = $id_anhos
EOD;
                    $records = CN_TABLE::executeSQL($sql);
                    /*
                     * Se crea validacion para nuevo año - 20170105
                     */
                    if (count($records) > 0) {

                        $consecutivo = $records[0]['consecutivo'];

                        $request['no_contrato'] = $consecutivo;

                        $sql = <<<EOD
update co_consecutivo_ca set consecutivo =($consecutivo+1) where id_anhos = $id_anhos
EOD;
                    } else {
                        $consecutivo = 1;

                        $request['no_contrato'] = $consecutivo;

                        $sql = <<<EOD
Insert into co_consecutivo_ca (ID_CONSECUTIVO_CA,ID_ANHOS,CONSECUTIVO) values (null,'$id_anhos',($consecutivo+1)) 
EOD;
                    }
                    CN_TABLE::executeSQL($sql);
                }
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto

        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Validacion de solo un contrato por seleccion - 20200331::LAVILA
     * 
     * @param \sfWebRequest $request
     * @return string 
     */
    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;
        $id_seleccion_ep = $request['id_seleccion_ep'];

        /*
         *  Validar la operación, ya sea por SQL
         */ $sql = <<<EOD
SELECT
    *
FROM co_contrato
where
id_seleccion_ep = $id_seleccion_ep 
and estado = 1
and activo = 1 
EOD;
        $records = CN_TABLE::executeSQL($sql);

        /*
         *  Generar errores en $errors
         */
        if (count($records) > 0) {
            $errors['mensaje'] = "Ya existe un registro de contrato para el proceso de selección. Favor Verificar";
            $errors['servicio'] = "co_contrato";
        }

        return $errors;
    }

    protected function validateUpdate(sfWebRequest $request) {
        //valor por defecto
        $errors = null;
        $id_contrato = $request['id_contrato'];
        $cerrar_contrato = $request['cerrar_contrato'];
        if ($cerrar_contrato) {

            $sql = <<<EOD
        select adjunto_contrato from co_contrato tab0
                where id_contrato = $id_contrato
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $adjunto = $records[0]['adjunto_contrato'];

            $sql = <<<EOD
        select id_rp from co_legaliza_contrato tab0
                where id_contrato = $id_contrato
EOD;
            $records = CN_TABLE::executeSQL($sql);
            if (count($records) > 0) {
                $id_rp = $records[0]['id_rp'];

                if ($id_rp == "") {

                    $errors['mensaje'] = "No ha realizado el registro del RP. Favor Verificar";
                    $errors['servicio'] = "co_contrato";
                }
            } else {
                $errors['mensaje'] = "No ha realizado el registro del RP. Favor Verificar";
                $errors['servicio'] = "co_contrato";
            }
        }

        /*
         *  Validar la operación, ya sea por SQL
         */



        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    private function htmlClear($string) {

        $string = str_replace('<p>', '<p align="justify">', $string);
        $string = str_replace('<br>', '<br/>', $string);
        $string = str_replace('class=', '', $string);
        $string = str_replace('<img', '', $string);
        $string = str_replace('<td>X</td>', '<td align="center">X</td>', $string);
        //$string = str_replace('<td align="top">', '<td align="justify">', $string);
        //$string = str_replace('<td align="justify">X</td>', '<td align="center">X</td>', $string);
        $string = str_replace('<td rowspan="2">', '<td rowspan="2" align="justify">', $string);

        $string = str_replace('<font size="2">', '<font size="10">', $string);
        $string = str_replace('<font size="3">', '<font size="12">', $string);
        $string = str_replace('<font size="4">', '<font size="14">', $string);
        $string = str_replace('<font size="5">', '<font size="18">', $string);
        $string = str_replace('<font size="6">', '<font size="24">', $string);
        $string = str_replace('<font size="7">', '<font size="36">', $string);
        $string = str_replace('<table ', '<center><table ', $string);
        $string = str_replace('</table> ', '</table></center>', $string);
        $string = str_replace('<table ', '<table border="1"', $string);

        $string = str_replace('size="2"', 'size="10"', $string);
        $string = str_replace('size="3"', 'size="12"', $string);
        $string = str_replace('size="4"', 'size="14"', $string);
        $string = str_replace('size="5"', 'size="18"', $string);
        $string = str_replace('size="6"', 'size="24"', $string);
        $string = str_replace('size="7"', 'size="36"', $string);

        $string = str_replace('border="0"', 'border="1"', $string);


        $string = str_replace('<div>', '<div align="justify">', $string);
        $string = str_replace('&amp;amp;amp;amp;amp;nbsp;', ' ', $string);
        $string = str_replace('&amp;amp;amp;amp;nbsp;', ' ', $string);
        $string = str_replace('&amp;amp;amp;nbsp;', ' ', $string);
        $string = str_replace('&amp;amp;nbsp;', '', $string);
        $string = str_replace('&amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;amp;nbsp;', '', $string);
        $string = str_replace('<style type="text/css">P { margin-bottom: 0.08in; direction: ltr; color: rgb(0, 0, 0); line-height: 100%; text-align: justify; widows: 2; orphans: 2; }P.western { font-family: "Tahoma",sans-serif; font-size: 11pt; }P.cjk { font-family: "Times New Roman",serif; font-size: 11pt; }P.ctl { font-family: "Tahoma",sans-serif; font-size: 11pt; }A:link { color: rgb(0, 0, 255); }</style>', ' ', $string);

        $string = str_replace('<td colspan="2">', '<td colspan="2" align="justify">', $string);
        $string = str_replace('<td rowspan="3">', '<td rowspan="3" align="justify">', $string);
        $string = str_replace('<td colspan="3">', '<td colspan="3" align="justify">', $string);
        $string = str_replace('<td rowspan="4">', '<td rowspan="4" align="justify">', $string);
        $string = str_replace('<td colspan="4">', '<td colspan="4" align="justify">', $string);
        $string = str_replace('  ', ' ', $string);
        $string = str_replace('   ', ' ', $string);
        $string = str_replace('    ', ' ', $string);
        $string = str_replace('	    ', ' ', $string);
        $string = str_replace('		    ', ' ', $string);
        //$string = str_replace('<span lang="ES-TRAD">', '<span>', $string);
        $string = str_replace('<span lang="ES-COL">', '<span>', $string);
        $string = str_replace('<!-- @page { size: 21cm 29.7cm; margin: 2cm } P { margin-bottom: 0.21cm } -->', '', $string);
        $string = str_replace('<p lang="es-MX" align="justify">', '', $string);
        //$string = str_replace('<span>', '', $string);
        //$string = str_replace('</span>', '', $string); #Este es el que MAS jode :::::::::::::::::
        $string = str_replace('valign', 'align', $string);
        ;
        $string = str_replace('width=', '', $string);
        //    $string = str_replace('&nbsp;', '', $string);
        //      $string = str_replace('cellspacing=', '', $string);
        //      $string = str_replace('cellpadding=', '', $string);
        $string = str_replace('bordercolor=', '', $string);
        $string = str_replace('<td>', '<td align="justify">', $string);
        $string = str_replace('<li>', '<li align="justify">', $string);
        $string = str_replace('style=', '', $string);
        $string = str_replace('<br clear="all">', '', $string);
        return trim($string);
    }

}
